/* 
 * ROPStop is Copyright (c) 2012-2014 Barton P. Miller. Written by Emily R. Jacobson.
 *
 * This file is part of ROPStop.
 *
 * ROPStop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * ROPStop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with ROPStop.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __ACCESSORS_H_
#define __ACCESSORS_H_

#include "CodeObject.h"
#include "globals.h"
#include "walker.h"
#include "CodeSource.h"
#include "walker.h"
#include "Instruction.h"

using namespace std;
using namespace Dyninst;

ParseAPI::Function * getFrameFunc(Stackwalker::Walker * walker, Address insn);
bool isVsyscallPage(std::string libName);
Address getRelAddr(Address addr, std::string libName, Address libLoad);
ParseAPI::SymtabCodeSource* getCodeSource(Stackwalker::Walker * walker, string name, Address load, unsigned size);
ParseAPI::CodeObject * getCodeObject(Stackwalker::Walker * walker, string name, Address load, unsigned size);
std::set<ParseAPI::CodeRegion *> getCodeRegions(ParseAPI::CodeSource * cs, Address addr);
bool getLibraryAndSize(Stackwalker::Walker * walker, Address pc, std::string & name, Address & load, unsigned & size); 
bool getPrevInsn(Stackwalker::Walker * walker,
        ProcControlAPI::Process::const_ptr proc,
        Address addr,
        InstructionAPI::Instruction::Ptr & insn,
        Address & insn_addr);

#endif
