/* 
 * ROPStop is Copyright (c) 2012-2014 Barton P. Miller. Written by Emily R. Jacobson.
 *
 * This file is part of ROPStop.
 *
 * ROPStop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * ROPStop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with ROPStop.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __FINDCALLEE_H_
#define __FINDCALLEE_H_

#include "walker.h"
#include "CFG.h"
#include "CodeSource.h"

using namespace std;
using namespace Dyninst;

bool findTailCallee(Stackwalker::Walker * walker,
        ParseAPI::Block * srcblock,
        ParseAPI::Edge * edge,
        ParseAPI::SymtabCodeSource * srcCS,
        ParseAPI::Function *&func,
        Address libLoad);

bool findCalleeFunc(Stackwalker::Walker * walker,
        Address callInsn,
        ParseAPI::SymtabCodeSource * srcCS,
        ParseAPI::Function *&func,
        Address libLoad,
        Address targetAddr);

bool findCallee(Stackwalker::Walker * walker,
        ParseAPI::Block * srcblock,
        ParseAPI::SymtabCodeSource * srcCS,
        Address callInsn,
        ParseAPI::Function *&func,
        Address libLoad);

#endif
