/* 
 * ROPStop is Copyright (c) 2012-2014 Barton P. Miller. Written by Emily R. Jacobson.
 *
 * This file is part of ROPStop.
 *
 * ROPStop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * ROPStop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with ROPStop.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __MANUALWALK_H_
#define __MANUALWALK_H_

#include <stack>
#include "PCProcess.h"
#include "walker.h"
#include "frame.h"
#include "CFG.h"
#include "CodeSource.h"
#include "CodeObject.h"
#include "globals.h"

using namespace std;
using namespace Dyninst;

bool findCallee(Stackwalker::Walker * walker,
        ParseAPI::Block * srcblock,
        ParseAPI::SymtabCodeSource * srcCS,
        Address callInsn,
        ParseAPI::Function *&func);

bool manualWalkStack(Stackwalker::Walker * walker, 
        ProcControlAPI::Process::const_ptr proc,
       ProcControlAPI::Thread::ptr thread, 
        MachRegisterVal val,
        std::stack<callLocation> & callstack,
        InstructionAPI::Instruction::Ptr & syscall,
        Address & syscallAddr,
        std::string & error_message);

#endif
