/* 
 * ROPStop is Copyright (c) 2012-2014 Barton P. Miller. Written by Emily R. Jacobson.
 *
 * This file is part of ROPStop.
 *
 * ROPStop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * ROPStop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with ROPStop.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PRINTERS_H_
#define __PRINTERS_H_

#include "frame.h"
#include "steppergroup.h"
#include "procstate.h"

using namespace std;
using namespace Dyninst;

void printStepperGroup(Stackwalker::StepperGroup * steppergroup);

std::string printFrameInfo(Stackwalker::Frame & frame, bool full);

void printCallStack(vector<Stackwalker::Frame> & callStack);

void printCallgraph(Stackwalker::Walker * walker);

void printRusage();

#endif
