/* 
 * ROPStop is Copyright (c) 2012-2014 Barton P. Miller. Written by Emily R. Jacobson.
 *
 * This file is part of ROPStop.
 *
 * ROPStop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * ROPStop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with ROPStop.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __VALIDPC_H__
#define __VALIDPC_H__

#include "dyntypes.h"
#include "CodeObject.h"
#include "Instruction.h"

using namespace std;
using namespace Dyninst;

bool validPC(Stackwalker::Walker * walker,
        PID pid, 
        MachRegisterVal pc, 
        ParseAPI::CodeObject * co, 
        std::set<ParseAPI::CodeRegion *> & regions,
        std::string libName,
        Address libLoad,
        unsigned libSize,
        InstructionAPI::Instruction::Ptr & instr,
        ParseAPI::Block *& block);

#endif
