/* 
 * ROPStop is Copyright (c) 2012-2014 Barton P. Miller. Written by Emily R. Jacobson.
 *
 * This file is part of ROPStop.
 *
 * ROPStop is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * ROPStop is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with ROPStop.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef __PREVINSN_H_
#define __PREVINSN_H_

/* Includes */
#include <stdio.h>
#include <getopt.h>
#include <iostream>
#include <sstream>

#include "dyntypes.h"

/* ProcControl includes */
#include "PCProcess.h"
#include "PCErrors.h"

/* Stackwalker includes */
#include "walker.h"
#include "frame.h"
#include "basetypes.h"
#include "framestepper.h"
#include "steppergroup.h"
#include "swk_errors.h"

/* InstructionAPI includes */
#include "Instruction.h"
#include "InstructionDecoder.h"

using namespace std;
using namespace Dyninst;

bool getInsn(ProcControlAPI::Process::const_ptr proc,
        unsigned char * ptr, 
        int size,
        InstructionAPI::Instruction::Ptr & insn);

bool isInsnACall(InstructionAPI::Instruction::Ptr insn);

bool validRA(Stackwalker::Walker * walker,
        ProcControlAPI::Process::const_ptr proc, 
        Address addr,
        InstructionAPI::Instruction::Ptr & insn,
        Address & insn_addr);

#endif
